from PyQt4.QtCore import *
from PyQt4.QtGui import *

class ImageSequence(QObject):
    """
    The ImageSequence class stores a sequence of frames for an animation.
    """

    # sensible limit (probably more than practical)
    maxFrame = 1000

    def __init__(self):
        QObject.__init__(self)
        self.images = []

    def openImageSequence(self, fileNameFormat):
        img = self._readImages(str(fileNameFormat))
        if len(img)>0: # did we read any images in?
            self.images = img
            return True
        else:
            return False

    def _readImages(self, fileNameFormat):
        img=[]
        try:
            for i in xrange(ImageSequence.maxFrame):
                # try and read in frame i, stop if not possible
                fileName = fileNameFormat % i
                loadedImage = QImage()
                if not loadedImage.load(fileName):
                    break
                img.append(loadedImage)
        finally:
            pass
        return img 

    def numFrames(self):
        return len(self.images)

    def getFrame(self, frame):
        if frame<0 or frame>=len(self.images):
            return None
        else:
            return self.images[frame]
