from PyQt4.QtCore import *
from PyQt4.QtGui import *
from imagesequence import ImageSequence

class ImageView(QWidget):
    """
    The ImageView class displays a frames from an ImageSequence
    """

    def __init__(self, parent = None):
        QWidget.__init__(self, parent)
        self.imgseq = None
        self.frame = 0
        self.setMinimumSize(QSize(640, 360)) # sensible default

    def setImageSequence(self, imgseq):
        self.imgseq = imgseq
        self.frame = 0
        self.update()

    def setFrame(self, f):
        if f!=self.frame and f>=0:
            self.frame = f
            self.update()

    def paintEvent(self, event):
        img = self.imgseq.getFrame(self.frame)
        if img!=None:
            painter = QPainter(self)
            dirtyRect = event.rect()
            painter.drawImage(dirtyRect, img, dirtyRect)
